package com.gxwebsoft.apps.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.apps.service.BcAgentService;
import com.gxwebsoft.apps.entity.BcAgent;
import com.gxwebsoft.apps.param.BcAgentParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 代报餐管理控制器
 *
 * @author 科技小王子
 * @since 2023-04-24 19:25:59
 */
@Api(tags = "代报餐管理管理")
@RestController
@RequestMapping("/api/apps/bc-agent")
public class BcAgentController extends BaseController {
    @Resource
    private BcAgentService bcAgentService;

    @PreAuthorize("hasAuthority('apps:bcAgent:list')")
    @OperationLog
    @ApiOperation("分页查询代报餐管理")
    @GetMapping("/page")
    public ApiResult<PageResult<BcAgent>> page(BcAgentParam param) {
        // 使用关联查询
      return success(bcAgentService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('apps:bcAgent:list')")
    @OperationLog
    @ApiOperation("查询全部代报餐管理")
    @GetMapping()
    public ApiResult<List<BcAgent>> list(BcAgentParam param) {
        // 使用关联查询
        return success(bcAgentService.listRel(param));
    }

    @PreAuthorize("hasAuthority('apps:bcAgent:list')")
    @OperationLog
    @ApiOperation("根据id查询代报餐管理")
    @GetMapping("/{id}")
    public ApiResult<BcAgent> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(bcAgentService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('apps:bcAgent:save')")
    @OperationLog
    @ApiOperation("添加代报餐管理")
    @PostMapping()
    public ApiResult<?> save(@RequestBody BcAgent bcAgent) {
        if (bcAgentService.save(bcAgent)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:bcAgent:update')")
    @OperationLog
    @ApiOperation("修改代报餐管理")
    @PutMapping()
    public ApiResult<?> update(@RequestBody BcAgent bcAgent) {
        if (bcAgentService.updateById(bcAgent)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:bcAgent:remove')")
    @OperationLog
    @ApiOperation("删除代报餐管理")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (bcAgentService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('apps:bcAgent:save')")
    @OperationLog
    @ApiOperation("批量添加代报餐管理")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<BcAgent> list) {
        if (bcAgentService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:bcAgent:update')")
    @OperationLog
    @ApiOperation("批量修改代报餐管理")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<BcAgent> batchParam) {
        if (batchParam.update(bcAgentService, "agent_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:bcAgent:remove')")
    @OperationLog
    @ApiOperation("批量删除代报餐管理")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (bcAgentService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
